using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
    public struct SpriteAssets
    {
        public static Texture2D FleshyTexture;
        public static Texture2D FleshyTexture2;
        public static Texture2D FleshyTexture3;
        public static Texture2D FleshyTexture4;
        public static Texture2D FleshyTexture5;
    }

    public class Mod
    {
        public static void Main()
        {
            //by JulianMagicCraft
            SpriteAssets.FleshyTexture = ModAPI.LoadTexture("flesh.png");
            SpriteAssets.FleshyTexture2 = ModAPI.LoadTexture("flesh2.png");
            SpriteAssets.FleshyTexture3 = ModAPI.LoadTexture("flesh3.png");
            SpriteAssets.FleshyTexture4 = ModAPI.LoadTexture("flesh4.png");
            SpriteAssets.FleshyTexture5 = ModAPI.LoadTexture("flesh5.png");
            ModAPI.RegisterLiquid(Scp610Syringe.Scp610Serum.ID, new Scp610Syringe.Scp610Serum());

            ModAPI.Register(
          new Modification()
          {
              OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),
              NameOverride = "!SCP-610 Syringe ",
              DescriptionOverride = "Contains the dangerous and contagious SCP-610 Virus",
              CategoryOverride = ModAPI.FindCategory("Chemistry"),
              ThumbnailOverride = ModAPI.LoadSprite("thumb.png"),
              AfterSpawn = (Instance) =>
              {
                
                  UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                  Instance.GetOrAddComponent<Scp610Syringe>();
              }
          }
      );

 

        }

        public class Scp610Syringe : SyringeBehaviour
        {

            public override string GetLiquidID() => Scp610Serum.ID;

            public class Scp610Serum : Liquid
            {
                public const string ID = "Scp610Serum";

                public Scp610Serum()
                {
                    Color = new UnityEngine.Color(1f, 0f, 0f, 1f);
                }

                public override void OnEnterLimb(LimbBehaviour limbjmc)
                {


                    var persony = limbjmc.Person;
                    var heady = persony.transform.Find("Head");

                    if(heady.gameObject.GetComponent<Scp610Core>() == null)
                    {
                        heady.gameObject.AddComponent<Scp610Core>();
                    }

                }

                public override void OnUpdate(BloodContainer container)
                {


                }


                public override void OnEnterContainer(BloodContainer container)
                {

                }


                public override void OnExitContainer(BloodContainer container)
                {

                }

            }
        }

        public class Scp610Core : MonoBehaviour
        {
           
            public void Start()
            {
                StartCoroutine(meatloaf());
            }

            public void Update()
            {
                var person = gameObject.GetComponent<LimbBehaviour>().Person;

                foreach (var jmc in person.Limbs)
                {
                    jmc.IsZombie = false;
                    jmc.Health = jmc.InitialHealth;
                    jmc.Numbness = 0f;
                    jmc.HealBone();

                    jmc.Person.Braindead = false;
                    jmc.Person.BrainDamaged = false;
                    jmc.Person.Consciousness = 1f;
                    jmc.Person.ShockLevel = 0f;
                    //jmc.Person.PainLevel = 0f;
                    jmc.Person.OxygenLevel = 1f;
                    jmc.Person.AdrenalineLevel = 1f;
                    jmc.ImmuneToDamage = true;

                    CirculationBehaviour circulationBehaviour = jmc.CirculationBehaviour;
                    float amount = circulationBehaviour.GetAmount(jmc.GetOriginalBloodType());
                    if (amount < 0.1f)
                    {
                        circulationBehaviour.AddLiquid(jmc.GetOriginalBloodType(), 1f - amount);
                    }
                    circulationBehaviour.BloodFlow = 1f;
                    circulationBehaviour.HealBleeding();
                    circulationBehaviour.BleedingRate = 0f;
                    circulationBehaviour.IsPump = circulationBehaviour.WasInitiallyPumping;
                }
            }

            public IEnumerator meatloaf()
            {
                var person = gameObject.GetComponent<LimbBehaviour>().Person;

                foreach (var xx in person.Limbs)
                {
                    xx.Person.PainLevel = 100f;
                }
                    yield return new WaitForSeconds(2);

                foreach (var xy in person.Limbs)
                {
                    xy.Person.PainLevel = 100f;
                }
                yield return new WaitForSeconds(2);

                var jmcflesh = UnityEngine.Random.Range(1, 6);

                if(jmcflesh == 1)
                {
                    person.SetBodyTextures(SpriteAssets.FleshyTexture);
                } else if(jmcflesh == 2)
                {
                    person.SetBodyTextures(SpriteAssets.FleshyTexture2);
                }
                else if (jmcflesh == 3)
                {
                    person.SetBodyTextures(SpriteAssets.FleshyTexture3);
                }
                else if (jmcflesh == 4)
                {
                    person.SetBodyTextures(SpriteAssets.FleshyTexture4);
                }
                else if (jmcflesh == 5)
                {
                    person.SetBodyTextures(SpriteAssets.FleshyTexture5);
                }




                foreach (var libi in person.Limbs)
                {
                    libi.gameObject.AddComponent<Scp610Jmc>();
                }

                HatefulMutationFlesh();
               
            }

            public void HatefulMutationFlesh()
            {
                var jmcFleshStore = UnityEngine.Random.Range(1, 6);
                var perbson = gameObject.GetComponent<LimbBehaviour>().Person;

                if (jmcFleshStore == 1)
                {
                    var head = perbson.transform.Find("Head");
                    var basketball = Instantiate(head.gameObject);
                    basketball.transform.SetParent(head);
                    basketball.transform.localPosition = new Vector3(0.0f, 0.0f);
                    basketball.transform.localEulerAngles = Vector3.zero;
                    basketball.transform.localScale = Vector2.one;
                    basketball.AddComponent<Fleshy>();
                } else if(jmcFleshStore == 2)
                {
                    var armz = perbson.transform.Find("BackArm").Find("UpperArm");
                    var foodball = Instantiate(armz.gameObject);
                    foodball.transform.SetParent(armz);
                    foodball.transform.localPosition = new Vector3(0.0f, 0.0f);
                    foodball.transform.localEulerAngles = Vector3.zero;
                    foodball.transform.localScale = Vector2.one;
                    foodball.AddComponent<Fleshy>();
                }
                else if (jmcFleshStore == 3)
                {
                    var lb = perbson.transform.Find("Body").Find("LowerBody");
                    var chickennuggys = perbson.transform.Find("BackLeg").Find("UpperLeg");
                    var kfc = Instantiate(chickennuggys.gameObject);
                    kfc.transform.SetParent(lb);
                    kfc.transform.localPosition = new Vector3(0.0f, 0.0f);
                    kfc.transform.localEulerAngles = Vector3.zero;
                    kfc.transform.localScale = Vector2.one;
                    kfc.AddComponent<Fleshy>();
                }
                else if (jmcFleshStore == 4)
                {
                    var armz = perbson.transform.Find("BackArm").Find("UpperArm");
                    var foodball = Instantiate(armz.gameObject);
                    foodball.transform.SetParent(armz);
                    foodball.transform.localPosition = new Vector3(0.0f, 0.0f);
                    foodball.transform.localEulerAngles = Vector3.zero;
                    foodball.transform.localScale = Vector2.one;
                    foodball.AddComponent<Fleshy>();

                    var amzz = perbson.transform.Find("BackArm").Find("LowerArm");
                    var jmcball = Instantiate(amzz.gameObject);
                    jmcball.transform.SetParent(armz);
                    jmcball.transform.localPosition = new Vector3(0.0f, 0.0f);
                    jmcball.transform.localEulerAngles = Vector3.zero;
                    jmcball.transform.localScale = Vector2.one;
                    jmcball.AddComponent<Fleshy>();

                }

                var ultramulation = UnityEngine.Random.Range(1, 6);
                if(ultramulation == 3)
                {
                    HatefulMutationFlesh();
                }

            }

            }

        public class Scp610Jmc : MonoBehaviour
        {
            public void Start()
            {
                
                var persons = gameObject.GetComponent<LimbBehaviour>().Person;
                persons.PainLevel = 0f;
               // gameObject.GetComponent<SpriteRenderer>().color = new Color32(199, 36, 0, 255);

            }

            void OnCollisionEnter2D(Collision2D julianmagiccraft)
            {
                var infectionmectiontraction = UnityEngine.Random.Range(1, 7);
                if (infectionmectiontraction == 3)
                {
                    var perp = julianmagiccraft.gameObject.GetComponent<LimbBehaviour>().Person;
                    var hay = perp.transform.Find("Head");

                    if (hay.gameObject.GetComponent<Scp610Core>() == null)
                    {
                        ModAPI.Notify("Another victim has been infected with the SCP-610 disease");
                        hay.gameObject.AddComponent<Scp610Core>();
                    }
                }
            }

            }
        public class Fleshy : MonoBehaviour
        {
            public void Update()
            {
                var person = gameObject.GetComponent<LimbBehaviour>().Person;

                foreach (var jmc in person.Limbs)
                {
                    jmc.IsZombie = false;
                    jmc.Health = jmc.InitialHealth;
                    jmc.Numbness = 0f;
                    jmc.HealBone();

                    jmc.Person.Braindead = false;
                    jmc.Person.BrainDamaged = false;
                    jmc.Person.Consciousness = 1f;
                    jmc.Person.ShockLevel = 0f;
                    //jmc.Person.PainLevel = 0f;
                    jmc.Person.OxygenLevel = 1f;
                    jmc.Person.AdrenalineLevel = 1f;
                    jmc.ImmuneToDamage = true;

                    CirculationBehaviour circulationBehaviour = jmc.CirculationBehaviour;
                    float amount = circulationBehaviour.GetAmount(jmc.GetOriginalBloodType());
                    if (amount < 0.1f)
                    {
                        circulationBehaviour.AddLiquid(jmc.GetOriginalBloodType(), 1f - amount);
                    }
                    circulationBehaviour.BloodFlow = 1f;
                    circulationBehaviour.HealBleeding();
                    circulationBehaviour.BleedingRate = 0f;
                    circulationBehaviour.IsPump = circulationBehaviour.WasInitiallyPumping;
                }
            }
        }



        }





    }

   
    